Debian Bug report logs - #315570
libarpack2: symbol duplication with LAPACK

version graph

Package: libarpack2; Maintainer for libarpack2 is Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>; Source for libarpack2 is src:arpack.

Reported by: Andreas Kloeckner <mathem@tiker.net>

Date: Thu, 23 Jun 2005 16:18:02 UTC

Severity: normal

Tags: patch

Found in version 2.1-8

Fixed in version arpack/2.1+parpack96-1

Done: Christophe Prud'homme <prudhomm@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Christophe Prud'homme <prudhomm@mit.edu>:
Bug#315570; Package libarpack2. Full text and rfc822 format available.

Acknowledgement sent to Andreas Kloeckner <mathem@tiker.net>:
New Bug report received and forwarded. Copy sent to Christophe Prud'homme <prudhomm@mit.edu>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Andreas Kloeckner <mathem@tiker.net>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: libarpack2: symbol duplication with LAPACK
Date: Thu, 23 Jun 2005 18:08:44 +0200
[Message part 1 (text/plain, inline)]
Package: libarpack2
Version: 2.1-8
Severity: normal
Tags: patch


This evening, I ran into a pretty frustrating problem with ARPACK. It
aborted without being able to compute an Arnoldi factorization from
within a custom Python extension, but the same snippet of code (with the same matrix!)
would work just fine when executed from the command line in a plain C++
program.

To make a long story short, I eventually tracked down the root cause:
Both LAPACK and ARPACK define a routine called SECOND, but with
different call signatures. LAPACK's copy is a function, whereas ARPACK's
copy is a subroutine. Usually, all goes well, and the linker is
intelligent enough to pick the right copy in all instances. I was
unfortunate enough to be in a situation where that was not the case. The
call to the wrong SECOND messed up the stack, and things got really
strange from there. (For example, DLARNV returned a NaN instead of a
proper number.) Apparently, the dynamic linker that loaded the Python
module resolved the SECOND symbol in ARPACK to the LAPACK one.

Hence, the ARPACK-supplied SECOND routine needs to be renamed. The
attached patch (a revised version of a quick sed job) realizes this
suggestion by renaming the routine to ARSCND (as in "ARpack SeCoND"),
which fixed the problem for me.  Apparently, somebody else on the Octave
team [1] ran into a similar problem, but got only unhelpful replies.

Andreas

[1] http://www.octave.org/octave-lists/archive/help-octave.2004/msg01466.html

-- System Information:
Debian Release: testing/unstable
  APT prefers testing
  APT policy: (500, 'testing'), (99, 'unstable')
Architecture: i386 (i686)
Shell:  /bin/sh linked to /bin/bash
Kernel: Linux 2.6.11
Locale: LANG=C, LC_CTYPE=C (charmap=ANSI_X3.4-1968)

Versions of packages libarpack2 depends on:
ii  atlas3-base [liblapack.s 3.6.0-19        Automatically Tuned Linear Algebra
ii  blas                     1.1-14          Basic Linear Algebra Subroutines, 
ii  lapack3 [liblapack.so.3] 3.0.20000531a-6 library of linear algebra routines
ii  libc6                    2.3.2.ds1-22    GNU C Library: Shared libraries an
ii  refblas3 [libblas.so.3]  1.2-8           Basic Linear Algebra Subroutines 3

-- no debconf information
[arpack-arscnd-2.patch.gz (application/octet-stream, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Christophe Prud'homme <prudhomm@mit.edu>:
Bug#315570; Package libarpack2. Full text and rfc822 format available.

Acknowledgement sent to Andreas Klöckner <mathem@tiker.net>:
Extra info received and forwarded to list. Copy sent to Christophe Prud'homme <prudhomm@mit.edu>. Full text and rfc822 format available.

Message #10 received at 315570@bugs.debian.org (full text, mbox):

From: Andreas Klöckner <mathem@tiker.net>
To: 315570@bugs.debian.org
Subject: Upstream already contacted
Date: Fri, 24 Jun 2005 21:26:13 +0200
[Message part 1 (text/plain, inline)]
I sent Dr. Lehoucq an email about this. Seems like they'll put out a fix (or 
accept mine) in due course.

Andreas
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Christophe Prud'homme <prudhomm@mit.edu>:
Bug#315570; Package libarpack2. Full text and rfc822 format available.

Acknowledgement sent to "Christophe Prud'homme" <christophe.prudhomme@epfl.ch>:
Extra info received and forwarded to list. Copy sent to Christophe Prud'homme <prudhomm@mit.edu>. Full text and rfc822 format available.

Message #15 received at 315570@bugs.debian.org (full text, mbox):

From: "Christophe Prud'homme" <christophe.prudhomme@epfl.ch>
To: Andreas KlXXckner <mathem@tiker.net>, 315570@bugs.debian.org
Subject: Re: Bug#315570: Upstream already contacted
Date: Sat, 25 Jun 2005 11:49:06 +0200
[ Vendredi 24 Juin 2005 21:26 ]
| I sent Dr. Lehoucq an email about this. Seems like they'll put out a fix
| (or accept mine) in due course.
|
| Andreas

Andreas 

I did not have a look at your fix yet but I will ASAP.

thank you for your contribution!

Best regards
C.
-- 
Christophe Prud'homme
EPFL SB IACS CMCS
MA B2 534 (Bâtiment MA)
Station 8
CH-1015 Lausanne
Tel: +41 (0)21 693 25 47
Fax: +41 (0)21 693 43 03



Information forwarded to debian-bugs-dist@lists.debian.org, Christophe Prud'homme <prudhomm@mit.edu>:
Bug#315570; Package libarpack2. Full text and rfc822 format available.

Acknowledgement sent to Andreas Klöckner <mathem@tiker.net>:
Extra info received and forwarded to list. Copy sent to Christophe Prud'homme <prudhomm@mit.edu>. Full text and rfc822 format available.

Message #20 received at 315570@bugs.debian.org (full text, mbox):

From: Andreas Klöckner <mathem@tiker.net>
To: rblehou@sandia.gov
Cc: 315570@bugs.debian.org
Subject: Updated SECOND Patch
Date: Fri, 1 Jul 2005 01:11:24 +0200
[Message part 1 (text/plain, inline)]
Dear Dr. Lehoucq:

The attached patch is an updated version of the ARPACK SECOND fix. It applies 
to ARPACK96 *with* patch.tar.gz applied, unlike the previous rendition. It 
also renames second.f to arscnd.f, with the appropriate changes to the 
Makefile.

I've done some testing on it, it works for me.

Andreas
[arpack-arscnd-3.patch.gz (application/x-gzip, attachment)]
[Message part 3 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Christophe Prud'homme <prudhomm@mit.edu>:
Bug#315570; Package libarpack2. Full text and rfc822 format available.

Acknowledgement sent to Andreas Kloeckner <inform@tiker.net>:
Extra info received and forwarded to list. Copy sent to Christophe Prud'homme <prudhomm@mit.edu>. Full text and rfc822 format available.

Message #25 received at 315570@bugs.debian.org (full text, mbox):

From: Andreas Kloeckner <inform@tiker.net>
To: Debian Bug Tracking System <315570@bugs.debian.org>
Subject: libarpack2: any news on the symbol duplication?
Date: Sun, 12 Feb 2006 23:21:12 -0500
Package: libarpack2
Version: 2.1-8
Followup-For: Bug #315570

I just ran into this bug again, and I've not heard anything back from
Dr. Lehoucq. Is there any chance of getting this into Debian?

Andreas

-- System Information:
Debian Release: testing/unstable
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'testing'), (500, 'stable')
Architecture: i386 (i686)
Shell:  /bin/sh linked to /bin/bash
Kernel: Linux 2.6.15.3
Locale: LANG=de_DE.UTF-8, LC_CTYPE=de_DE.UTF-8 (charmap=UTF-8)

Versions of packages libarpack2 depends on:
ii  atlas3-base [liblapack.s 3.6.0-20        Automatically Tuned Linear Algebra
ii  atlas3-sse2 [liblapack.s 3.6.0-20        Automatically Tuned Linear Algebra
ii  lapack3 [liblapack.so.3] 3.0.20000531a-6 library of linear algebra routines
ii  libc6                    2.3.5-13        GNU C Library: Shared libraries an
ii  refblas3 [libblas.so.3]  1.2-8           Basic Linear Algebra Subroutines 3

Versions of packages libarpack2 recommends:
ii  atlas3-base                   3.6.0-20   Automatically Tuned Linear Algebra

-- no debconf information



Information forwarded to debian-bugs-dist@lists.debian.org, Christophe Prud'homme <prudhomm@mit.edu>:
Bug#315570; Package libarpack2. Full text and rfc822 format available.

Acknowledgement sent to "Christophe Prud'homme" <prudhomm@debian.org>:
Extra info received and forwarded to list. Copy sent to Christophe Prud'homme <prudhomm@mit.edu>. Full text and rfc822 format available.

Message #30 received at 315570@bugs.debian.org (full text, mbox):

From: "Christophe Prud'homme" <prudhomm@debian.org>
To: Andreas Kloeckner <inform@tiker.net>, 315570@bugs.debian.org
Subject: Re: Bug#315570: libarpack2: any news on the symbol duplication?
Date: Tue, 14 Feb 2006 07:47:16 +0100
[ Monday 13 February 2006 05:21 ]
| Package: libarpack2
| Version: 2.1-8
| Followup-For: Bug #315570
|
| I just ran into this bug again, and I've not heard anything back from
| Dr. Lehoucq. Is there any chance of getting this into Debian?

Hi

it seems that I lost track of this bug. Sorry.
I will look into it ASAP.
Please don't hesitate to remind me in a week or two if nothing happenned.

Best regards
C.
-- 
Debian Developer - http://people.debian.org/~prudhomm/
Scienfific computing packages maintainer
Fingerprint = 3703 50DE 7A9F 024E 0F26  0D07 A18F B40B D4BE 1450



Information forwarded to debian-bugs-dist@lists.debian.org, Christophe Prud'homme <prudhomm@mit.edu>:
Bug#315570; Package libarpack2. Full text and rfc822 format available.

Acknowledgement sent to Andreas Kloeckner <inform@tiker.net>:
Extra info received and forwarded to list. Copy sent to Christophe Prud'homme <prudhomm@mit.edu>. Full text and rfc822 format available.

Message #35 received at 315570@bugs.debian.org (full text, mbox):

From: Andreas Kloeckner <inform@tiker.net>
To: Debian Bug Tracking System <315570@bugs.debian.org>
Subject: libarpack2: Can you do something about this? Pretty please?
Date: Mon, 26 Jun 2006 22:21:47 -0500
Package: libarpack2
Followup-For: Bug #315570

I just ran into this again... :/

Just to clarify: This bug does not hit everybody who uses ARPACK, but
those who do get hit, get anything from spurious errors to segfaults. I
think it's pretty serious.

Thanks
Andreas


-- System Information:
Debian Release: testing/unstable
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'testing'), (500, 'stable')
Architecture: i386 (i686)
Shell:  /bin/sh linked to /bin/bash
Kernel: Linux 2.6.17.1
Locale: LANG=de_DE.UTF-8, LC_CTYPE=de_DE.UTF-8 (charmap=UTF-8)



Information forwarded to debian-bugs-dist@lists.debian.org, Christophe Prud'homme <prudhomm@mit.edu>:
Bug#315570; Package libarpack2. Full text and rfc822 format available.

Acknowledgement sent to Georg Baum <Georg.Baum@post.rwth-aachen.de>:
Extra info received and forwarded to list. Copy sent to Christophe Prud'homme <prudhomm@mit.edu>. Full text and rfc822 format available.

Message #40 received at 315570@bugs.debian.org (full text, mbox):

From: Georg Baum <Georg.Baum@post.rwth-aachen.de>
To: 315570@bugs.debian.org
Subject: Please fix this bug - it makes the package unusable
Date: Tue, 18 Sep 2007 19:28:21 +0200
The subject says it. I have spent a considerable time debugging this until I 
found this report. The latest patch by Andreas (although it did not apply 
cleanly) fixed the issue. Here are my observations:

I use arpack from a C++ program via some selfmade bindings. Without the 
patch it works fine on an amd 64bit machine using gcc/gfortran 4.0.1 (SuSE 
10.0). I get lots of nans in znaupd on two amd 32bit machines: One running 
SuSE 9.2 using gcc/g77 3.3, and the other one running Debian etch using 
gfortran/gcc 4.1.
arpack was self compiled on the SuSE machines (using the debian source 
packages - a procedure I often use successfully for scientific software 
that is not available on SuSE, thanks to the good suppport in Debian) and I 
used the .deb on the debian machine.


Georg




Tags added: pending Request was from Anibal Monsalve Salazar <anibal@debian.org> to control@bugs.debian.org. (Fri, 15 Feb 2008 11:06:05 GMT) Full text and rfc822 format available.

Reply sent to Christophe Prud'homme <prudhomm@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Andreas Kloeckner <mathem@tiker.net>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #47 received at 315570-close@bugs.debian.org (full text, mbox):

From: Christophe Prud'homme <prudhomm@debian.org>
To: 315570-close@bugs.debian.org
Subject: Bug#315570: fixed in arpack 2.1+parpack96-1
Date: Sat, 23 Feb 2008 00:22:57 +0000
Source: arpack
Source-Version: 2.1+parpack96-1

We believe that the bug you reported is fixed in the latest version of
arpack, which is due to be installed in the Debian FTP archive:

arpack_2.1+parpack96-1.diff.gz
  to pool/main/a/arpack/arpack_2.1+parpack96-1.diff.gz
arpack_2.1+parpack96-1.dsc
  to pool/main/a/arpack/arpack_2.1+parpack96-1.dsc
arpack_2.1+parpack96.orig.tar.gz
  to pool/main/a/arpack/arpack_2.1+parpack96.orig.tar.gz
libarpack2-dbg_2.1+parpack96-1_i386.deb
  to pool/main/a/arpack/libarpack2-dbg_2.1+parpack96-1_i386.deb
libarpack2-dev_2.1+parpack96-1_i386.deb
  to pool/main/a/arpack/libarpack2-dev_2.1+parpack96-1_i386.deb
libarpack2_2.1+parpack96-1_i386.deb
  to pool/main/a/arpack/libarpack2_2.1+parpack96-1_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 315570@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Christophe Prud'homme <prudhomm@debian.org> (supplier of updated arpack package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Fri, 15 Feb 2008 10:58:51 +0100
Source: arpack
Binary: libarpack2 libarpack2-dev libarpack2-dbg
Architecture: source i386
Version: 2.1+parpack96-1
Distribution: unstable
Urgency: low
Maintainer: Debian Scientific Computing Team <pkg-scicomp-devel@lists.alioth.debian.org>
Changed-By: Christophe Prud'homme <prudhomm@debian.org>
Description: 
 libarpack2 - Fortran77 subroutines to solve large scale eigenvalue problems
 libarpack2-dbg - Fortran77 subroutines to solve large scale eigenvalue problems
 libarpack2-dev - Fortran77 subroutines to solve large scale eigenvalue problems
Closes: 195579 315570 390368 463926
Changes: 
 arpack (2.1+parpack96-1) unstable; urgency=low
 .
   [ Rafael Laboissiere ]
   * debian/control: Added XS-Vcs-Svn and XS-Vcs-Browser fields to the Source
     section
 .
   [Christophe Prud'homme]
   * RiceBSD.*: added license clarification
   * Bug fix: "Wishlist: parpack", thanks to Viral Shah (Closes: #195579).
   * debian/control: use gfortran
   * Bug fix: "arpack -- please Build-Depend on gfortran based lapack and
     blas.", thanks to Kumar Appaiah (Closes: #463926).
   * Bug fix: "libarpack2: symbol duplication with LAPACK", thanks to
     Andreas Kloeckner (Closes: #315570).
   * Bug fix: "libarpack2: cnapps.f not included on alpha (internal
     compiler error)", thanks to Niko Tyni (Closes: #390368).
Files: 
 46a9920298bb769efbb849db0d1bfd17 905 math optional arpack_2.1+parpack96-1.dsc
 0d2cf1147ac5423b86c4c621bc9ad8ec 2359371 math optional arpack_2.1+parpack96.orig.tar.gz
 4bffe0a3b9334ab581e9ff554fa67b59 11782 math optional arpack_2.1+parpack96-1.diff.gz
 20a2dc014ebd94f05e8e7435c2f7dc27 148354 libs optional libarpack2_2.1+parpack96-1_i386.deb
 58f8e7f745bab9507e95a3a313369d88 797542 libdevel optional libarpack2-dev_2.1+parpack96-1_i386.deb
 96f84dc2cd7138e1b2bd39e01d3a52a2 16388 libdevel extra libarpack2-dbg_2.1+parpack96-1_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)

iD8DBQFHtWn3oY+0C9S+FFARAqZYAJoCNxPQBe/1tNGKgAXaaOo06c4uawCfS0T4
WJQfD1KKsMNeV/me/BgooBI=
=EdnW
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sat, 06 Sep 2008 07:31:39 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 04:32:13 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.